# Webhook設定 更新

`PUT /v1/webhook_settings/{id}`

- operationId: `updateWebhookSetting`
- tags: Webhook設定

IDで指定したWebhook設定を更新します。


## コードサンプル

### cURL

```bash
curl \
    -X PUT \
    -H "Authorization:Bearer <Secret API Key>" \
    -H "Content-Type: application/json" \
    -d '{
    "signature": "WEBHOOK_FROM_FINCODE"
}' \
'https://api.test.fincode.jp/v1/webhook_settings/{id}'
```

### Node.js

```javascript
import { createFincode } from "@fincode/node";

const API_KEY = "<Secret API Key>";

(async () => {
    const fincode = createFincode({ apiKey: API_KEY, isLiveMode: false });

    const webhookSettingId = "<Webhook Setting ID>";

    try {
        // リクエストの送信
        const webhookSetting = await fincode.webhookSettings.update(
            webhookSettingId,
            {
                url: "https://your-service.example.com/v2/webhook-receiver",
            }
        );
    } catch (e) {
        // エラーの処理
    }
})();
```

### Go

```go
package main

import (
	"bytes"
	"encoding/json"
	"fmt"
	"log"
	"net/http"
)

func main() {

	apiKey := "<Secret API Key>"

	webhookSettingID := "<Webhook Setting ID>"

	body := UpdatingWebhookSettingRequest{
		URL: stringPointer("https://your-service.example.com/v2/webhook-receiver"),
	}

	marshalledBody, _ := json.Marshal(body)

	// リクエストの作成
	req, _ := http.NewRequest(
		"PUT",
		fmt.Sprintf("https://api.test.fincode.jp/v1/webhook_settings/%s", webhookSettingID),
		bytes.NewBuffer(marshalledBody),
	)

	req.Header.Set("Authorization", fmt.Sprintf("Bearer %s", apiKey))
	req.Header.Set("Content-Type", "application/json")

	// リクエストの送信
	client := &http.Client{}
	res, err := client.Do(req)
	if err != nil {
		log.Fatal(err)
	}
	defer res.Body.Close()

}

type UpdatingWebhookSettingRequest struct {
	URL       *string `json:"url"`
	Event     *string `json:"event"`
	Signature *string `json:"signature"`
}

func stringPointer(s string) *string {
	return &s
}
```

### PHP

```php
<?php

$apiKey = '<Secret API Key>';

$webhookSettingId = '<Webhook Setting ID>';

$baseUrl = "https://api.test.fincode.jp";
$endpoint = "/v1/webhook_settings/{$webhookSettingId}";
$headers = [
    "Authorization: Bearer " . $apiKey,
];

$data = json_encode([
    "url" => "https://your-service.example.com/v2/webhook-receiver",
]);

$session = curl_init();
curl_setopt($session, CURLOPT_URL, $baseUrl . $endpoint);
curl_setopt($session, CURLOPT_HTTPHEADER, $headers);
curl_setopt($session, CURLOPT_CUSTOMREQUEST, 'PUT');
curl_setopt($session, CURLOPT_POSTFIELDS, $data);
curl_setopt($session, CURLOPT_RETURNTRANSFER, true);
// curl_setopt($session, CURLOPT_SSL_VERIFYPEER, );
// curl_setopt($session, CURLOPT_SSL_VERIFYHOST, );

$response = curl_exec($session);

if ($response === false) {
    # エラー処理
    echo "cURL Error: " . curl_error($session);
} else {
    # APIからのデータを処理
    var_dump($response);
}

curl_close($session);
```

### Python 3

```python
import requests

api_key = '<Secret API Key>'

webhook_setting_id = '<Webhook Setting ID>'

url = f'https://api.test.fincode.jp/v1/webhook_settings/{webhook_setting_id}'

# ヘッダーを設定
headers = {
    'Authorization': f'Bearer {api_key}',
    'Content-Type': 'application/json'
}

data = {
    "signature": "WEBHOOK_FROM_FINCODE"
}

# HTTP POSTリクエストの送信
try:
    response = requests.put(url, headers=headers, json=data)

    # レスポンスの処理
    if response.status_code == 200:
        # 成功した場合の処理
        print(f"Success: {response.json()}")
    else:
        # エラーの処理
        print(f"Error: {response.json()}")
except requests.RequestException as e:
    # 通信エラーの処理
    print(f"Request error: {e}")
```

### Ruby

```ruby
require 'net/http'
require 'uri'
require 'json'


API_KEY = '<Secret API Key>'
BASE_URL = 'https://api.test.fincode.jp'

def main
    webhook_setting_id = '<Webhook Setting ID>'
    endpoint = "/v1/webhook_settings/#{webhook_setting_id}"
    
    uri = URI.parse(BASE_URL + endpoint)

    http = Net::HTTP.new(uri.host, uri.port)
    http.use_ssl = true

    data = {
        signature: "WEBHOOK_FROM_FINCODE"
    }

    # リクエストの作成
    request = Net::HTTP::Put.new(uri.request_uri)
    request['Authorization'] = "Bearer #{API_KEY}"
    request['Content-Type'] = 'application/json'

    request.body = data.to_json

    # リクエストの送信
    response = http.request(request)

    case response
    when Net::HTTPSuccess
        puts 'SUCCESS'
    else
        puts 'ERROR'
    end

    # レスポンスの表示
    puts response.body
end

main
```

## パラメータ

| 名前 | 位置 | 必須 | 型 | 説明 |
| --- | --- | --- | --- | --- |
| `id` | path | ✓ | WebhookSettingId_schema | Webhook設定のID |
| `Tenant-Shop-Id` | header |  | schema | <span class="smallText color--red-400">※ プラットフォームのメインショップのみ指定可</span> |

## リクエストボディ

Content-Type: `application/json`

| パラメータ | 型 | 必須 | 説明 |
| --- | --- | --- | --- |
| `url` | WebhookSetting_properties-url |  |  |
| `event` | FincodeEvent |  |  |
| `signature` | signature |  |  |

## レスポンス

### 200 リクエストに成功

| パラメータ | 型 | 必須 | 説明 |
| --- | --- | --- | --- |
| `id` | string |  | Webhook設定ID |
| `url` | string(uri) |  | Webhook通知先 URL |
| `event` | FincodeEvent |  |  |
| `signature` | string |  | 署名 |
| `created` | created |  |  |
| `updated` | updated |  |  |

### 400 不正なリクエスト

| パラメータ | 型 | 必須 | 説明 |
| --- | --- | --- | --- |
| `errors` | array<FincodeAPIError> |  |  |

